import { Resolver, ResolveOptions, MinimalResolveOptions } from '@yarnpkg/core';
import { Descriptor, Locator, DescriptorHash, Package } from '@yarnpkg/core';
import { LinkType } from '@yarnpkg/core';
export declare class ExecResolver implements Resolver {
    supportsDescriptor(descriptor: Descriptor, opts: MinimalResolveOptions): boolean;
    supportsLocator(locator: Locator, opts: MinimalResolveOptions): boolean;
    shouldPersistResolution(locator: Locator, opts: MinimalResolveOptions): boolean;
    bindDescriptor(descriptor: Descriptor, fromLocator: Locator, opts: MinimalResolveOptions): Descriptor;
    getResolutionDependencies(descriptor: Descriptor, opts: MinimalResolveOptions): never[];
    getCandidates(descriptor: Descriptor, dependencies: Map<DescriptorHash, Package>, opts: ResolveOptions): Promise<Locator[]>;
    getSatisfying(descriptor: Descriptor, references: Array<string>, opts: ResolveOptions): Promise<null>;
    resolve(locator: Locator, opts: ResolveOptions): Promise<{
        version: string;
        languageName: string;
        linkType: LinkType;
        dependencies: Map<import("@yarnpkg/core").IdentHash, Descriptor>;
        peerDependencies: Map<import("@yarnpkg/core").IdentHash, Descriptor>;
        dependenciesMeta: Map<string, Map<string | null, import("@yarnpkg/core").DependencyMeta>>;
        peerDependenciesMeta: Map<string, import("@yarnpkg/core").PeerDependencyMeta>;
        bin: Map<string, import("@yarnpkg/fslib").PortablePath>;
        locatorHash: import("@yarnpkg/core").LocatorHash;
        reference: string;
        identHash: import("@yarnpkg/core").IdentHash;
        scope: string | null;
        name: string;
    }>;
}
